﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Automation;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Telerik.Windows.Controls;

namespace SelfReferenceHierarchyTreeViewWPF
{
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            this.TreeView1.Loaded += new RoutedEventHandler(TreeView1_Loaded);

            this.DataContext = new DataItemCollection<DataItem>()
			{
				new DataItem () { Text = "Item 1", ID = 1, ParentID = 0, CheckState= ToggleState.Off, IsDropAllowed=true},
				new DataItem () { Text = "Item 2", ID = 2, ParentID = 0, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 3", ID = 3, ParentID = 0, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 1.1", ID = 5, ParentID = 1, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 1.2", ID = 6, ParentID = 1, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 1.3", ID = 7, ParentID = 1, CheckState= ToggleState.On, IsDropAllowed=true },
				new DataItem () { Text = "Item 2.1", ID = 8, ParentID = 2, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 2.2", ID = 9, ParentID = 2, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 2.3", ID = 10, ParentID = 2, CheckState= ToggleState.Off, IsDropAllowed=true},
				new DataItem () { Text = "Item 3.1", ID = 11, ParentID = 3, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 3.2", ID = 12, ParentID = 3, CheckState= ToggleState.Off, IsDropAllowed=true },
				new DataItem () { Text = "Item 3.3", ID = 13, ParentID = 3, CheckState= ToggleState.Off, IsDropAllowed=true }
			};
        }

        protected void TreeView1_Loaded(object sender, RoutedEventArgs e)
        {
            RadTreeView rtv = (RadTreeView)sender;
            rtv.ExpandAll();
            
            //rtv.ExpandItemByPath("Item 1|Item 1.3", "|");

            foreach (DataItem item in rtv.Items)
            {
                RadTreeViewItem tvi = rtv.ContainerFromItemRecursive(item);

                if (tvi.CheckState == ToggleState.On)
                {
                    tvi.IsExpanded = true;
                    tvi.IsSelected = true;
                }
            }
        }
    }
}
